import{s as Z,n as ee,o as te}from"../chunks/scheduler.37c15a92.js";import{S as ne,i as ae,g as l,s as i,r as C,A as ie,h as r,f as n,c as s,j as X,u as _,x as v,k as Y,y as se,a,v as P,d as L,t as k,w as T}from"../chunks/index.2bf4358c.js";import{C as oe}from"../chunks/CourseFloatingBanner.15ba07e6.js";import{H as U,E as le}from"../chunks/EditOnGithub.8916dc7c.js";function re(O){let o,N,y,E,m,q,g,z,h,R="Before jumping into Transformer models, let’s do a quick overview of what natural language processing is and why we care about it.",G,u,I,c,D="NLP is a field of linguistics and machine learning focused on understanding everything related to human language. The aim of NLP tasks is not only to understand single words individually, but to be able to understand the context of those words.",M,p,J="The following is a list of common NLP tasks, with some examples of each:",H,f,K="<li><strong>Classifying whole sentences</strong>: Getting the sentiment of a review, detecting if an email is spam, determining if a sentence is grammatically correct or whether two sentences are logically related or not</li> <li><strong>Classifying each word in a sentence</strong>: Identifying the grammatical components of a sentence (noun, verb, adjective), or the named entities (person, location, organization)</li> <li><strong>Generating text content</strong>: Completing a prompt with auto-generated text, filling in the blanks in a text with masked words</li> <li><strong>Extracting an answer from a text</strong>: Given a question and a context, extracting the answer to the question based on the information provided in the context</li> <li><strong>Generating a new sentence from an input text</strong>: Translating a text into another language, summarizing a text</li>",S,d,Q="NLP isn’t limited to written text though. It also tackles complex challenges in speech recognition and computer vision, such as generating a transcript of an audio sample or a description of an image.",W,w,j,x,V="Computers don’t process information in the same way as humans. For example, when we read the sentence “I am hungry,” we can easily understand its meaning. Similarly, given two sentences such as “I am hungry” and “I am sad,” we’re able to easily determine how similar they are. For machine learning (ML) models, such tasks are more difficult. The text needs to be processed in a way that enables the model to learn from it. And because language is complex, we need to think carefully about how this processing must be done. There has been a lot of research done on how to represent text, and we will look at some methods in the next chapter.",A,$,F,b,B;return m=new U({props:{title:"Natural Language Processing",local:"natural-language-processing",headingTag:"h1"}}),g=new oe({props:{chapter:1,classNames:"absolute z-10 right-0 top-0"}}),u=new U({props:{title:"What is NLP?",local:"what-is-nlp",headingTag:"h2"}}),w=new U({props:{title:"Why is it challenging?",local:"why-is-it-challenging",headingTag:"h2"}}),$=new le({props:{source:"https://github.com/huggingface/course/blob/main/chapters/en/chapter1/2.mdx"}}),{c(){o=l("meta"),N=i(),y=l("p"),E=i(),C(m.$$.fragment),q=i(),C(g.$$.fragment),z=i(),h=l("p"),h.textContent=R,G=i(),C(u.$$.fragment),I=i(),c=l("p"),c.textContent=D,M=i(),p=l("p"),p.textContent=J,H=i(),f=l("ul"),f.innerHTML=K,S=i(),d=l("p"),d.textContent=Q,W=i(),C(w.$$.fragment),j=i(),x=l("p"),x.textContent=V,A=i(),C($.$$.fragment),F=i(),b=l("p"),this.h()},l(e){const t=ie("svelte-u9bgzb",document.head);o=r(t,"META",{name:!0,content:!0}),t.forEach(n),N=s(e),y=r(e,"P",{}),X(y).forEach(n),E=s(e),_(m.$$.fragment,e),q=s(e),_(g.$$.fragment,e),z=s(e),h=r(e,"P",{"data-svelte-h":!0}),v(h)!=="svelte-9ahqc4"&&(h.textContent=R),G=s(e),_(u.$$.fragment,e),I=s(e),c=r(e,"P",{"data-svelte-h":!0}),v(c)!=="svelte-14hz609"&&(c.textContent=D),M=s(e),p=r(e,"P",{"data-svelte-h":!0}),v(p)!=="svelte-rkg1z0"&&(p.textContent=J),H=s(e),f=r(e,"UL",{"data-svelte-h":!0}),v(f)!=="svelte-19s7o39"&&(f.innerHTML=K),S=s(e),d=r(e,"P",{"data-svelte-h":!0}),v(d)!=="svelte-kv2x67"&&(d.textContent=Q),W=s(e),_(w.$$.fragment,e),j=s(e),x=r(e,"P",{"data-svelte-h":!0}),v(x)!=="svelte-1g6qo1w"&&(x.textContent=V),A=s(e),_($.$$.fragment,e),F=s(e),b=r(e,"P",{}),X(b).forEach(n),this.h()},h(){Y(o,"name","hf:doc:metadata"),Y(o,"content",me)},m(e,t){se(document.head,o),a(e,N,t),a(e,y,t),a(e,E,t),P(m,e,t),a(e,q,t),P(g,e,t),a(e,z,t),a(e,h,t),a(e,G,t),P(u,e,t),a(e,I,t),a(e,c,t),a(e,M,t),a(e,p,t),a(e,H,t),a(e,f,t),a(e,S,t),a(e,d,t),a(e,W,t),P(w,e,t),a(e,j,t),a(e,x,t),a(e,A,t),P($,e,t),a(e,F,t),a(e,b,t),B=!0},p:ee,i(e){B||(L(m.$$.fragment,e),L(g.$$.fragment,e),L(u.$$.fragment,e),L(w.$$.fragment,e),L($.$$.fragment,e),B=!0)},o(e){k(m.$$.fragment,e),k(g.$$.fragment,e),k(u.$$.fragment,e),k(w.$$.fragment,e),k($.$$.fragment,e),B=!1},d(e){e&&(n(N),n(y),n(E),n(q),n(z),n(h),n(G),n(I),n(c),n(M),n(p),n(H),n(f),n(S),n(d),n(W),n(j),n(x),n(A),n(F),n(b)),n(o),T(m,e),T(g,e),T(u,e),T(w,e),T($,e)}}}const me='{"title":"Natural Language Processing","local":"natural-language-processing","sections":[{"title":"What is NLP?","local":"what-is-nlp","sections":[],"depth":2},{"title":"Why is it challenging?","local":"why-is-it-challenging","sections":[],"depth":2}],"depth":1}';function ge(O){return te(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class fe extends ne{constructor(o){super(),ae(this,o,ge,re,Z,{})}}export{fe as component};
