import{s as xt,n as Pt,o as _t}from"../chunks/scheduler.37c15a92.js";import{S as kt,i as jt,g as i,s,r as m,A as qt,h as l,f as a,c as n,j as Tt,u as p,x as r,k as Qe,y as Ht,a as o,v as u,d as c,t as d,w as f}from"../chunks/index.2bf4358c.js";import{C as v}from"../chunks/CodeBlock.4f5fc1ad.js";import{H as De,E as Lt}from"../chunks/EditOnGithub.8916dc7c.js";function Jt(Oe){let b,ie,se,le,g,re,w,Ke='Bem-vindo(a) ao curso da Hugging Face! Essa introdução te guiará para a configuração do ambiente de trabalho. Se você está começando agora o curso, nós recomendamos que você primeiramente dê uma olhada no <a href="/course/chapter1">Capítulo 1</a>, para só então voltar aqui, configurar o ambiente e começar a por a mão no código.',me,y,et="Todas as bibliotecas que usaremos nesse curso estão disponíveis como pacotes do Python, então aqui iremos te mostrar como configurar o ambiente no Python e instalar as bibliotecas específicas que você precisará.",pe,C,tt="Abordaremos 2 modos de configurar o ambiente, usando um Colab notebook ou um ambiente virtual Python. Fique à vontade para escolher o que mais fizer sentido para você.  Para os iniciantes, recomendamos fortemente que vocês iniciem pelo Colab notebook.",ue,M,at="Note que nós não iremos cobrir o básico sobre o Windows. Se você estiver usando o Windows, recomendamos seguir as instruções pelo Colab notebook. Se estiver usando Linux ou macOS, você pode escolher qualquer uma das abordagens descritas aqui.",ce,T,ot='A maior parte do curso depende de você ter uma conta na Hugging Face. Recomendamos criar uma agora <a href="https://huggingface.co/join" rel="nofollow">criar uma conta</a>.',de,x,fe,P,st="Usar um notebook Colab é a maneira mais simples possível de configuração, coloque um notebook no seu navegador e se prepare para a codificação!",ve,_,nt=`Se você não está familiarizado com o Colab, recomendamos seguir essa [introdução]
(<a href="https://colab.research.google.com/notebooks/intro.ipynb" rel="nofollow">https://colab.research.google.com/notebooks/intro.ipynb</a>). O Colab permitirá você usar algumas acelerações de hardware, como GPUs ou TPUs, e é gratuito para ambientes de trabalho pequenos.`,be,k,it="Uma vez que você estiver confortável com o ambiente do Colab, crie um novo notebook e comece com essa configuração:",$e,$,lt='<img src="https://huggingface.co/datasets/huggingface-course/documentation-images/resolve/main/en/chapter0/new_colab.png" alt="An empty colab notebook" width="80%"/>',he,j,rt="O próximo passo é instalar as bibliotecas que serão usadas nesse curso. Usaremos <code>pip</code> para a instalação, que é o gerenciador de pacotes do Python. Nos notebooks, você pode rodar os comandos do sistema precedendo do caractere <code>!</code>, então você poderá instalar a biblioteca 🤗 Transformers da seguinte forma:",ge,q,we,H,mt="Você pode assegurar que o pacote foi instalado corretamente por meio de sua importação dentro do ambiente de execução do Python:",ye,L,Ce,h,pt='<img src="https://huggingface.co/datasets/huggingface-course/documentation-images/resolve/main/en/chapter0/install.gif" alt="A gif showing the result of the two commands above: installation and import" width="80%"/>',Me,J,ut="Isso instalará uma versão bem leve da 🤗 Transformers. Em particular, nenhum framework de aprendizagem de máquina (como PyTorch ou TensorFlow) estão instalados. Desde que iremos usar bastante de suas features na biblioteca, recomendamos instalar a versão de desenvolvimento, que vem com todas as dependências requisitadas para cada caso de uso imaginável:",Te,U,xe,I,ct="Isso levará um pouco de tempo, mas quando acabar você estará pronto/a para seguir o resto do curso!",Pe,G,_e,Z,dt='Se você perferir usar o ambiente virtual Python, o primeiro passo é instalar o Python no seu sistema. Nós recomendamos <a href="https://realpython.com/installing-python/" rel="nofollow">esse guia</a> para começar.',ke,z,ft="Uma vez instalado o Python, você será capaz de rodar os comandos do Python em seu terminal. Você pode iniciar por rodar o seguinte comando para ter certeza que está instalado corretamente antes de iniciar os seguintes passos: <code>python --version</code>. Isso irá imprimir na tela a versão do Python disponível no seu sistema.",je,W,vt="Quando você rodar um comando Python no seu terminal, como o <code>python --version</code>, você deve imaginar como um programa rodando seu comando como o “main” Python no seu sistema. Recomendamos manter essa instalação livre de qualquer pacote, e usando a para criar ambientes separados para cada aplicação que você for trabalhar - desse modo, cada aplicação pode ter suas próprias dependências e pacotes, e você não precisará se preocupar sobre potenciais problemas de compatibilidades com outras aplicações.",qe,V,bt='No Python isso é feito com <a href="https://docs.python.org/3/tutorial/venv.html" rel="nofollow"><em>ambientes virtuais</em></a>, que é uma árvore de diretórios que contém a instalação do Python com uma versão particular do mesmo juntamente com todos os pacotes que a aplicação precisa. Criar um ambiente virtual como esse pode ser feito com inúmeras ferramentas, mas usaremos o pacote oficial do Python para esse propósito, que se chama <a href="https://docs.python.org/3/library/venv.html#module-venv" rel="nofollow"><code>venv</code></a>.',He,N,$t="Primeiro, crie o diretório que você gostaria que sua aplicação existisse - por exemplo, você pode querer criar um novo diretório chamado <em>curso-transformers</em> na raíz de seu diretório home:",Le,B,Je,E,ht="Dentro desse diretório, crie um ambiente virtual usando o módulo Python <code>venv</code>:",Ue,R,Ie,X,gt="Agora você deve ter dentro um diretório chamado <em>.env</em> em sua pasta vazia:",Ge,F,Ze,S,ze,Y,wt="Você pode acessar e sair do seu ambiente virtual com os scripts <code>activate</code> e <code>deactivate</code>:",We,A,Ve,Q,yt="Você pode ter certeza que seu ambiente virtual está ativado rodando o comando <code>which python</code>: se ele apontar para o ambiente virtual, então você conseguiu ativa-lo com sucesso!",Ne,D,Be,O,Ee,K,Re,ee,Ct="Como na seção passada usando as instâncias do Google Colab, você precisará instalar os pacotes necessários para continuar. Novamente, você pode instalar a versão de desenvolvimento da 🤗 Transformers usando o gerenciador de pacotes <code>pip</code>:",Xe,te,Fe,ae,Mt="Você agora configurou tudo e está pronto para seguir!",Se,oe,Ye,ne,Ae;return g=new De({props:{title:"Introdução",local:"introdução",headingTag:"h1"}}),x=new De({props:{title:"Usando um notebook Google Colab",local:"usando-um-notebook-google-colab",headingTag:"h2"}}),q=new v({props:{code:"IXBpcCUyMGluc3RhbGwlMjB0cmFuc2Zvcm1lcnM=",highlighted:'!pip <span class="hljs-keyword">install</span> transformers',wrap:!1}}),L=new v({props:{code:"aW1wb3J0JTIwdHJhbnNmb3JtZXJz",highlighted:'<span class="hljs-keyword">import</span> transformers',wrap:!1}}),U=new v({props:{code:"IXBpcCUyMGluc3RhbGwlMjB0cmFuc2Zvcm1lcnMlNUJzZW50ZW5jZXBpZWNlJTVE",highlighted:'!pip <span class="hljs-keyword">install</span> transformers[sentencepiece]',wrap:!1}}),G=new De({props:{title:"Usando um ambiente virtual Python",local:"usando-um-ambiente-virtual-python",headingTag:"h2"}}),B=new v({props:{code:"bWtkaXIlMjB+JTJGdHJhbnNmb3JtZXJzLWNvdXJzZSUwQWNkJTIwfiUyRnRyYW5zZm9ybWVycy1jb3Vyc2U=",highlighted:`<span class="hljs-built_in">mkdir</span> ~/transformers-course
<span class="hljs-built_in">cd</span> ~/transformers-course`,wrap:!1}}),R=new v({props:{code:"cHl0aG9uJTIwLW0lMjB2ZW52JTIwLmVudg==",highlighted:'<span class="hljs-keyword">python</span> -m venv .<span class="hljs-keyword">env</span>',wrap:!1}}),F=new v({props:{code:"bHMlMjAtYQ==",highlighted:'<span class="hljs-built_in">ls</span> -a',wrap:!1}}),S=new v({props:{code:"LiUyMCUyMCUyMCUyMCUyMCUyMC4uJTIwJTIwJTIwJTIwLmVudg==",highlighted:'.      <span class="hljs-string">..</span>    <span class="hljs-string">.env</span>',wrap:!1}}),A=new v({props:{code:"JTIzJTIwQWN0aXZhdGUlMjB0aGUlMjB2aXJ0dWFsJTIwZW52aXJvbm1lbnQlMEFzb3VyY2UlMjAuZW52JTJGYmluJTJGYWN0aXZhdGUlMEElMEElMjMlMjBEZWFjdGl2YXRlJTIwdGhlJTIwdmlydHVhbCUyMGVudmlyb25tZW50JTBBZGVhY3RpdmF0ZQ==",highlighted:`<span class="hljs-comment"># Activate the virtual environment</span>
<span class="hljs-built_in">source</span> .<span class="hljs-built_in">env</span>/bin/activate

<span class="hljs-comment"># Deactivate the virtual environment</span>
deactivate`,wrap:!1}}),D=new v({props:{code:"d2hpY2glMjBweXRob24=",highlighted:'<span class="hljs-built_in">which</span> python',wrap:!1}}),O=new v({props:{code:"JTJGaG9tZSUyRiUzQ3VzZXIlM0UlMkZ0cmFuc2Zvcm1lcnMtY291cnNlJTJGLmVudiUyRmJpbiUyRnB5dGhvbg==",highlighted:'<span class="hljs-regexp">/home/</span>&lt;user&gt;<span class="hljs-regexp">/transformers-course/</span>.env<span class="hljs-regexp">/bin/</span>python',wrap:!1}}),K=new De({props:{title:"Instalando dependências",local:"instalando-dependências",headingTag:"h3"}}),te=new v({props:{code:"cGlwJTIwaW5zdGFsbCUyMCUyMnRyYW5zZm9ybWVycyU1QnNlbnRlbmNlcGllY2UlNUQlMjI=",highlighted:'pip <span class="hljs-keyword">install</span> <span class="hljs-string">&quot;transformers[sentencepiece]&quot;</span>',wrap:!1}}),oe=new Lt({props:{source:"https://github.com/huggingface/course/blob/main/chapters/pt/chapter0/1.mdx"}}),{c(){b=i("meta"),ie=s(),se=i("p"),le=s(),m(g.$$.fragment),re=s(),w=i("p"),w.innerHTML=Ke,me=s(),y=i("p"),y.textContent=et,pe=s(),C=i("p"),C.textContent=tt,ue=s(),M=i("p"),M.textContent=at,ce=s(),T=i("p"),T.innerHTML=ot,de=s(),m(x.$$.fragment),fe=s(),P=i("p"),P.textContent=st,ve=s(),_=i("p"),_.innerHTML=nt,be=s(),k=i("p"),k.textContent=it,$e=s(),$=i("div"),$.innerHTML=lt,he=s(),j=i("p"),j.innerHTML=rt,ge=s(),m(q.$$.fragment),we=s(),H=i("p"),H.textContent=mt,ye=s(),m(L.$$.fragment),Ce=s(),h=i("div"),h.innerHTML=pt,Me=s(),J=i("p"),J.textContent=ut,Te=s(),m(U.$$.fragment),xe=s(),I=i("p"),I.textContent=ct,Pe=s(),m(G.$$.fragment),_e=s(),Z=i("p"),Z.innerHTML=dt,ke=s(),z=i("p"),z.innerHTML=ft,je=s(),W=i("p"),W.innerHTML=vt,qe=s(),V=i("p"),V.innerHTML=bt,He=s(),N=i("p"),N.innerHTML=$t,Le=s(),m(B.$$.fragment),Je=s(),E=i("p"),E.innerHTML=ht,Ue=s(),m(R.$$.fragment),Ie=s(),X=i("p"),X.innerHTML=gt,Ge=s(),m(F.$$.fragment),Ze=s(),m(S.$$.fragment),ze=s(),Y=i("p"),Y.innerHTML=wt,We=s(),m(A.$$.fragment),Ve=s(),Q=i("p"),Q.innerHTML=yt,Ne=s(),m(D.$$.fragment),Be=s(),m(O.$$.fragment),Ee=s(),m(K.$$.fragment),Re=s(),ee=i("p"),ee.innerHTML=Ct,Xe=s(),m(te.$$.fragment),Fe=s(),ae=i("p"),ae.textContent=Mt,Se=s(),m(oe.$$.fragment),Ye=s(),ne=i("p"),this.h()},l(e){const t=qt("svelte-u9bgzb",document.head);b=l(t,"META",{name:!0,content:!0}),t.forEach(a),ie=n(e),se=l(e,"P",{}),Tt(se).forEach(a),le=n(e),p(g.$$.fragment,e),re=n(e),w=l(e,"P",{"data-svelte-h":!0}),r(w)!=="svelte-1sccyy7"&&(w.innerHTML=Ke),me=n(e),y=l(e,"P",{"data-svelte-h":!0}),r(y)!=="svelte-1pookyt"&&(y.textContent=et),pe=n(e),C=l(e,"P",{"data-svelte-h":!0}),r(C)!=="svelte-hteu4b"&&(C.textContent=tt),ue=n(e),M=l(e,"P",{"data-svelte-h":!0}),r(M)!=="svelte-1jj0tts"&&(M.textContent=at),ce=n(e),T=l(e,"P",{"data-svelte-h":!0}),r(T)!=="svelte-ivkibr"&&(T.innerHTML=ot),de=n(e),p(x.$$.fragment,e),fe=n(e),P=l(e,"P",{"data-svelte-h":!0}),r(P)!=="svelte-17gq0k5"&&(P.textContent=st),ve=n(e),_=l(e,"P",{"data-svelte-h":!0}),r(_)!=="svelte-sgko0w"&&(_.innerHTML=nt),be=n(e),k=l(e,"P",{"data-svelte-h":!0}),r(k)!=="svelte-1cq1pyk"&&(k.textContent=it),$e=n(e),$=l(e,"DIV",{class:!0,"data-svelte-h":!0}),r($)!=="svelte-1mpe2rl"&&($.innerHTML=lt),he=n(e),j=l(e,"P",{"data-svelte-h":!0}),r(j)!=="svelte-12fekw2"&&(j.innerHTML=rt),ge=n(e),p(q.$$.fragment,e),we=n(e),H=l(e,"P",{"data-svelte-h":!0}),r(H)!=="svelte-wjxdgq"&&(H.textContent=mt),ye=n(e),p(L.$$.fragment,e),Ce=n(e),h=l(e,"DIV",{class:!0,"data-svelte-h":!0}),r(h)!=="svelte-1cj51wg"&&(h.innerHTML=pt),Me=n(e),J=l(e,"P",{"data-svelte-h":!0}),r(J)!=="svelte-7bpxg4"&&(J.textContent=ut),Te=n(e),p(U.$$.fragment,e),xe=n(e),I=l(e,"P",{"data-svelte-h":!0}),r(I)!=="svelte-vtko65"&&(I.textContent=ct),Pe=n(e),p(G.$$.fragment,e),_e=n(e),Z=l(e,"P",{"data-svelte-h":!0}),r(Z)!=="svelte-aa8hrd"&&(Z.innerHTML=dt),ke=n(e),z=l(e,"P",{"data-svelte-h":!0}),r(z)!=="svelte-138fb3f"&&(z.innerHTML=ft),je=n(e),W=l(e,"P",{"data-svelte-h":!0}),r(W)!=="svelte-17pm0s0"&&(W.innerHTML=vt),qe=n(e),V=l(e,"P",{"data-svelte-h":!0}),r(V)!=="svelte-xls7gt"&&(V.innerHTML=bt),He=n(e),N=l(e,"P",{"data-svelte-h":!0}),r(N)!=="svelte-1odsa49"&&(N.innerHTML=$t),Le=n(e),p(B.$$.fragment,e),Je=n(e),E=l(e,"P",{"data-svelte-h":!0}),r(E)!=="svelte-mfntj"&&(E.innerHTML=ht),Ue=n(e),p(R.$$.fragment,e),Ie=n(e),X=l(e,"P",{"data-svelte-h":!0}),r(X)!=="svelte-12wnrn8"&&(X.innerHTML=gt),Ge=n(e),p(F.$$.fragment,e),Ze=n(e),p(S.$$.fragment,e),ze=n(e),Y=l(e,"P",{"data-svelte-h":!0}),r(Y)!=="svelte-gngv1z"&&(Y.innerHTML=wt),We=n(e),p(A.$$.fragment,e),Ve=n(e),Q=l(e,"P",{"data-svelte-h":!0}),r(Q)!=="svelte-1usv6k6"&&(Q.innerHTML=yt),Ne=n(e),p(D.$$.fragment,e),Be=n(e),p(O.$$.fragment,e),Ee=n(e),p(K.$$.fragment,e),Re=n(e),ee=l(e,"P",{"data-svelte-h":!0}),r(ee)!=="svelte-1nh9cdm"&&(ee.innerHTML=Ct),Xe=n(e),p(te.$$.fragment,e),Fe=n(e),ae=l(e,"P",{"data-svelte-h":!0}),r(ae)!=="svelte-1ag3kf5"&&(ae.textContent=Mt),Se=n(e),p(oe.$$.fragment,e),Ye=n(e),ne=l(e,"P",{}),Tt(ne).forEach(a),this.h()},h(){Qe(b,"name","hf:doc:metadata"),Qe(b,"content",Ut),Qe($,"class","flex justify-center"),Qe(h,"class","flex justify-center")},m(e,t){Ht(document.head,b),o(e,ie,t),o(e,se,t),o(e,le,t),u(g,e,t),o(e,re,t),o(e,w,t),o(e,me,t),o(e,y,t),o(e,pe,t),o(e,C,t),o(e,ue,t),o(e,M,t),o(e,ce,t),o(e,T,t),o(e,de,t),u(x,e,t),o(e,fe,t),o(e,P,t),o(e,ve,t),o(e,_,t),o(e,be,t),o(e,k,t),o(e,$e,t),o(e,$,t),o(e,he,t),o(e,j,t),o(e,ge,t),u(q,e,t),o(e,we,t),o(e,H,t),o(e,ye,t),u(L,e,t),o(e,Ce,t),o(e,h,t),o(e,Me,t),o(e,J,t),o(e,Te,t),u(U,e,t),o(e,xe,t),o(e,I,t),o(e,Pe,t),u(G,e,t),o(e,_e,t),o(e,Z,t),o(e,ke,t),o(e,z,t),o(e,je,t),o(e,W,t),o(e,qe,t),o(e,V,t),o(e,He,t),o(e,N,t),o(e,Le,t),u(B,e,t),o(e,Je,t),o(e,E,t),o(e,Ue,t),u(R,e,t),o(e,Ie,t),o(e,X,t),o(e,Ge,t),u(F,e,t),o(e,Ze,t),u(S,e,t),o(e,ze,t),o(e,Y,t),o(e,We,t),u(A,e,t),o(e,Ve,t),o(e,Q,t),o(e,Ne,t),u(D,e,t),o(e,Be,t),u(O,e,t),o(e,Ee,t),u(K,e,t),o(e,Re,t),o(e,ee,t),o(e,Xe,t),u(te,e,t),o(e,Fe,t),o(e,ae,t),o(e,Se,t),u(oe,e,t),o(e,Ye,t),o(e,ne,t),Ae=!0},p:Pt,i(e){Ae||(c(g.$$.fragment,e),c(x.$$.fragment,e),c(q.$$.fragment,e),c(L.$$.fragment,e),c(U.$$.fragment,e),c(G.$$.fragment,e),c(B.$$.fragment,e),c(R.$$.fragment,e),c(F.$$.fragment,e),c(S.$$.fragment,e),c(A.$$.fragment,e),c(D.$$.fragment,e),c(O.$$.fragment,e),c(K.$$.fragment,e),c(te.$$.fragment,e),c(oe.$$.fragment,e),Ae=!0)},o(e){d(g.$$.fragment,e),d(x.$$.fragment,e),d(q.$$.fragment,e),d(L.$$.fragment,e),d(U.$$.fragment,e),d(G.$$.fragment,e),d(B.$$.fragment,e),d(R.$$.fragment,e),d(F.$$.fragment,e),d(S.$$.fragment,e),d(A.$$.fragment,e),d(D.$$.fragment,e),d(O.$$.fragment,e),d(K.$$.fragment,e),d(te.$$.fragment,e),d(oe.$$.fragment,e),Ae=!1},d(e){e&&(a(ie),a(se),a(le),a(re),a(w),a(me),a(y),a(pe),a(C),a(ue),a(M),a(ce),a(T),a(de),a(fe),a(P),a(ve),a(_),a(be),a(k),a($e),a($),a(he),a(j),a(ge),a(we),a(H),a(ye),a(Ce),a(h),a(Me),a(J),a(Te),a(xe),a(I),a(Pe),a(_e),a(Z),a(ke),a(z),a(je),a(W),a(qe),a(V),a(He),a(N),a(Le),a(Je),a(E),a(Ue),a(Ie),a(X),a(Ge),a(Ze),a(ze),a(Y),a(We),a(Ve),a(Q),a(Ne),a(Be),a(Ee),a(Re),a(ee),a(Xe),a(Fe),a(ae),a(Se),a(Ye),a(ne)),a(b),f(g,e),f(x,e),f(q,e),f(L,e),f(U,e),f(G,e),f(B,e),f(R,e),f(F,e),f(S,e),f(A,e),f(D,e),f(O,e),f(K,e),f(te,e),f(oe,e)}}}const Ut='{"title":"Introdução","local":"introdução","sections":[{"title":"Usando um notebook Google Colab","local":"usando-um-notebook-google-colab","sections":[],"depth":2},{"title":"Usando um ambiente virtual Python","local":"usando-um-ambiente-virtual-python","sections":[{"title":"Instalando dependências","local":"instalando-dependências","sections":[],"depth":3}],"depth":2}],"depth":1}';function It(Oe){return _t(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Vt extends kt{constructor(b){super(),jt(this,b,It,Jt,xt,{})}}export{Vt as component};
