import{s as Yl,n as Sl,o as Fl}from"../chunks/scheduler.37c15a92.js";import{S as Wl,i as Ol,g as a,s,r as m,A as Ql,h as r,f as l,c as i,j as Nl,u as o,x as f,k as c,y as Xl,a as n,v as u,d as p,t as g,w as v}from"../chunks/index.2bf4358c.js";import{Y as St}from"../chunks/Youtube.1e50a667.js";import{C as Zl}from"../chunks/CourseFloatingBanner.06521e8b.js";import{H as d,E as Jl}from"../chunks/EditOnGithub.8916dc7c.js";function Kl(Ft){let x,Ee,Pe,je,w,qe,M,Be,P,Wt="在本節中，我們將深入瞭解 Transformer 模型的架構。",Re,y,De,E,Ot="以下是 Transformer 模型（簡短）歷史中的一些關鍵節點：",Ae,T,Qt='<img class="block dark:hidden" src="https://huggingface.co/datasets/huggingface-course/documentation-images/resolve/main/en/chapter1/transformers_chrono.svg" alt="A brief chronology of Transformers models."/> <img class="hidden dark:block" src="https://huggingface.co/datasets/huggingface-course/documentation-images/resolve/main/en/chapter1/transformers_chrono-dark.svg" alt="A brief chronology of Transformers models."/>',Ie,j,Xt='<a href="https://arxiv.org/abs/1706.03762" rel="nofollow">Transformer 架構</a> 於 2017 年 6 月推出。原本研究的重點是翻譯任務。隨後推出了幾個有影響力的模型，包括',Ve,q,Zt='<li><p><strong>2018 年 6 月</strong>: <a href="https://cdn.openai.com/research-covers/language-unsupervised/language_understanding_paper.pdf" rel="nofollow">GPT</a>, 第一個預訓練的 Transformer 模型，用於各種 NLP 任務並獲得極好的結果</p></li> <li><p><strong>2018 年 10 月</strong>: <a href="https://arxiv.org/abs/1810.04805" rel="nofollow">BERT</a>, 另一個大型預訓練模型，該模型旨在生成更好的句子摘要（下一章將詳細介紹！）</p></li> <li><p><strong>2019 年 2 月</strong>: <a href="https://cdn.openai.com/better-language-models/language_models_are_unsupervised_multitask_learners.pdf" rel="nofollow">GPT-2</a>, GPT 的改進（並且更大）版本，由於道德問題沒有立即公開發布</p></li> <li><p><strong>2019 年 10 月</strong>: <a href="https://arxiv.org/abs/1910.01108" rel="nofollow">DistilBERT</a>, BERT 的提煉版本，速度提高 60%，內存減輕 40%，但仍保留 BERT 97% 的性能</p></li> <li><p><strong>2019 年 10 月</strong>: <a href="https://arxiv.org/abs/1910.13461" rel="nofollow">BART</a> 和 <a href="https://arxiv.org/abs/1910.10683" rel="nofollow">T5</a>, 兩個使用與原始 Transformer 模型相同架構的大型預訓練模型（第一個這樣做）</p></li> <li><p><strong>2020 年 5 月</strong>, <a href="https://arxiv.org/abs/2005.14165" rel="nofollow">GPT-3</a>, GPT-2 的更大版本，無需微調即可在各種任務上表現良好（稱爲零樣本學習）</p></li>',ze,B,Jt="這個列表並不全面，只是爲了突出一些不同類型的 Transformer 模型。大體上，它們可以分爲三類：",Ge,R,Kt="<li>GPT-like (也被稱作自迴歸Transformer模型)</li> <li>BERT-like (也被稱作自動編碼Transformer模型)</li> <li>BART/T5-like (也被稱作序列到序列的 Transformer模型)</li>",Ue,D,el="稍後我們將更深入地探討這些分類。",Ne,A,Ye,I,tl="上面提到的所有 Transformer 模型（GPT、BERT、BART、T5 等）都被訓練爲語言模型。這意味着他們已經以無監督學習的方式接受了大量原始文本的訓練。無監督學習是一種訓練類型，其中目標是根據模型的輸入自動計算的。這意味着不需要人工來標記數據！",Se,V,ll="這種類型的模型可以對其訓練過的語言進行統計理解，但對於特定的實際任務並不是很有用。因此，一般的預訓練模型會經歷一個稱爲<em>遷移學習</em>的過程。在此過程中，模型在給定任務上以監督方式（即使用人工註釋標籤）進行微調。",Fe,z,nl="任務的一個例子是閱讀 <em>n</em> 個單詞的句子，預測下一個單詞。這被稱爲因果語言建模，因爲輸出取決於過去和現在的輸入。",We,h,sl='<img class="block dark:hidden" src="https://huggingface.co/datasets/huggingface-course/documentation-images/resolve/main/en/chapter1/causal_modeling.svg" alt="Example of causal language modeling in which the next word from a sentence is predicted."/> <img class="hidden dark:block" src="https://huggingface.co/datasets/huggingface-course/documentation-images/resolve/main/en/chapter1/causal_modeling-dark.svg" alt="Example of causal language modeling in which the next word from a sentence is predicted."/>',Oe,G,il="另一個例子是<em>遮罩語言建模</em>，該模型預測句子中的遮住的詞。",Qe,$,al='<img class="block dark:hidden" src="https://huggingface.co/datasets/huggingface-course/documentation-images/resolve/main/en/chapter1/masked_modeling.svg" alt="Example of masked language modeling in which a masked word from a sentence is predicted."/> <img class="hidden dark:block" src="https://huggingface.co/datasets/huggingface-course/documentation-images/resolve/main/en/chapter1/masked_modeling-dark.svg" alt="Example of masked language modeling in which a masked word from a sentence is predicted."/>',Xe,U,Ze,N,rl="除了一些特例（如 DistilBERT）外，實現更好性能的一般策略是增加模型的大小以及預訓練的數據量。",Je,C,fl='<img src="https://huggingface.co/datasets/huggingface-course/documentation-images/resolve/main/en/chapter1/model_parameters.png" alt="Number of parameters of recent Transformers models" width="90%"/>',Ke,Y,ml="不幸的是，訓練模型，尤其是大型模型，需要大量的數據，時間和計算資源。它甚至會對環境產生影響，如下圖所示。",et,_,ol='<img class="block dark:hidden" src="https://huggingface.co/datasets/huggingface-course/documentation-images/resolve/main/en/chapter1/carbon_footprint.svg" alt="The carbon footprint of a large language model."/> <img class="hidden dark:block" src="https://huggingface.co/datasets/huggingface-course/documentation-images/resolve/main/en/chapter1/carbon_footprint-dark.svg" alt="The carbon footprint of a large language model."/>',tt,S,lt,F,ul="Transformers是由一個團隊領導的（非常大的）模型項目，該團隊試圖減少預訓練對環境的影響，通過運行大量試驗以獲得最佳超參數。",nt,W,pl="想象一下，如果每次一個研究團隊、一個學生組織或一家公司想要訓練一個模型，都從頭開始訓練的。這將導致巨大的、不必要的浪費！",st,O,gl="這就是爲什麼共享語言模型至關重要：共享經過訓練的權重，當遇見新的需求時在預訓練的權重之上進行微調，可以降低訓練模型訓練的算力和時間消耗，降低全球的總體計算成本和碳排放。",it,Q,at,X,rt,Z,vl="<em>預訓練是</em>訓練模型前的一個操作：隨機初始化權重，在沒有任何先驗知識的情況下開始訓練。",ft,k,cl='<img class="block dark:hidden" src="https://huggingface.co/datasets/huggingface-course/documentation-images/resolve/main/en/chapter1/pretraining.svg" alt="The pretraining of a language model is costly in both time and money."/> <img class="hidden dark:block" src="https://huggingface.co/datasets/huggingface-course/documentation-images/resolve/main/en/chapter1/pretraining-dark.svg" alt="The pretraining of a language model is costly in both time and money."/>',mt,J,dl="這種預訓練通常是在非常大量的數據上進行的。因此，它需要大量的數據，而且訓練可能需要幾周的時間。",ot,K,xl="另一方面，<em>微調</em>是在模型經過預訓練後完成的訓練。要執行微調，首先需要獲取一個經過預訓練的語言模型，然後使用特定於任務的數據集執行額外的訓練。等等，爲什麼不直接爲最後的任務而訓練呢？有幾個原因：",ut,ee,Tl="<li>預訓練模型已經在與微調數據集有一些相似之處的數據集上進行了訓練。因此，微調過程能夠利用模型在預訓練期間獲得的知識（例如，對於NLP問題，預訓練模型將對您在任務中使用的語言有某種統計規律上的理解）。</li> <li>由於預訓練模型已經在大量數據上進行了訓練，因此微調需要更少的數據來獲得不錯的結果。</li> <li>出於同樣的原因，獲得好結果所需的時間和資源要少得多</li>",pt,te,hl="例如，可以利用英語的預訓練過的模型，然後在arXiv語料庫上對其進行微調，從而形成一個基於科學/研究的模型。微調只需要有限的數據量：預訓練模型獲得的知識可以“遷移”到目標任務上，因此被稱爲<em>遷移學習</em>。",gt,b,$l='<img class="block dark:hidden" src="https://huggingface.co/datasets/huggingface-course/documentation-images/resolve/main/en/chapter1/finetuning.svg" alt="The fine-tuning of a language model is cheaper than pretraining in both time and money."/> <img class="hidden dark:block" src="https://huggingface.co/datasets/huggingface-course/documentation-images/resolve/main/en/chapter1/finetuning-dark.svg" alt="The fine-tuning of a language model is cheaper than pretraining in both time and money."/>',vt,le,Cl="因此，微調模型具有較低的時間、數據、財務和環境成本。迭代不同的微調方案也更快、更容易，因爲與完整的預訓練相比，訓練的約束更少。",ct,ne,_l="這個過程也會比從頭開始的訓練（除非你有很多數據）取得更好的效果，這就是爲什麼你應該總是嘗試利用一個預訓練的模型—一個儘可能接近你手頭的任務的模型—並對其進行微調。",dt,se,xt,ie,kl="在這一部分，我們將介紹Transformer模型的一般架構。如果你不理解其中的一些概念，不要擔心；下文將詳細介紹每個組件。",Tt,ae,ht,re,$t,fe,bl="該模型主要由兩個塊組成：",Ct,me,Ll="<li><strong>Encoder (左側)</strong>: 編碼器接收輸入並構建其表示（其特徵）。這意味着對模型進行了優化，以從輸入中獲得理解。</li> <li><strong>Decoder (右側)</strong>: 解碼器使用編碼器的表示（特徵）以及其他輸入來生成目標序列。這意味着該模型已針對生成輸出進行了優化。</li>",_t,L,Hl='<img class="block dark:hidden" src="https://huggingface.co/datasets/huggingface-course/documentation-images/resolve/main/en/chapter1/transformers_blocks.svg" alt="Architecture of a Transformers models"/> <img class="hidden dark:block" src="https://huggingface.co/datasets/huggingface-course/documentation-images/resolve/main/en/chapter1/transformers_blocks-dark.svg" alt="Architecture of a Transformers models"/>',kt,oe,wl="這些部件中的每一個都可以獨立使用，具體取決於任務：",bt,ue,Ml="<li><strong>Encoder-only models</strong>: 適用於需要理解輸入的任務，如句子分類和命名實體識別。</li> <li><strong>Decoder-only models</strong>: 適用於生成任務，如文本生成。</li> <li><strong>Encoder-decoder models</strong> 或者 <strong>sequence-to-sequence models</strong>: 適用於需要根據輸入進行生成的任務，如翻譯或摘要。</li>",Lt,pe,Pl="在後面的部分中，我們將單獨地深入研究這些體系結構。",Ht,ge,wt,ve,yl='Transformer模型的一個關鍵特性是<em>注意力層</em>。事實上，介紹Transformer架構的文章的標題是<a href="https://arxiv.org/abs/1706.03762" rel="nofollow">“注意力就是你所需要的”</a>! 我們將在課程的後面更加深入地探索注意力層；現在，您需要知道的是，這一層將告訴模型在處理每個單詞的表示時，要特別重視您傳遞給它的句子中的某些單詞（並且或多或少地忽略其他單詞）。',Mt,ce,El="把它放在語境中，考慮將文本從英語翻譯成法語的任務。在輸入“You like this course”的情況下，翻譯模型還需要注意相鄰的單詞“You”，以獲得單詞“like”的正確翻譯，因爲在法語中，動詞“like”的變化取決於主題。然而，句子的其餘部分對於該詞的翻譯沒有用處。同樣，在翻譯“this”時，模型也需要注意“course”一詞，因爲“this”的翻譯不同，取決於相關名詞是單數還是複數。同樣，句子中的其他單詞對於“this”的翻譯也不重要。對於更復雜的句子（以及更復雜的語法規則），模型需要特別注意可能出現在句子中更遠位置的單詞，以便正確地翻譯每個單詞。",Pt,de,jl="同樣的概念也適用於與自然語言相關的任何任務：一個詞本身有一個含義，但這個含義受語境的影響很大，語境可以是研究該詞之前或之後的任何其他詞（或多個詞）。",yt,xe,ql="現在您已經瞭解了注意力層的含義，讓我們更仔細地瞭解Transformer架構。",Et,Te,jt,he,Bl="Transformer架構最初是爲翻譯而設計的。在訓練期間，編碼器接收特定語言的輸入（句子），而解碼器需要輸出對應語言的翻譯。在編碼器中，注意力層可以使用一個句子中的所有單詞（正如我們剛纔看到的，給定單詞的翻譯可以取決於它在句子中的其他單詞）。然而，解碼器是按順序工作的，並且只能注意它已經翻譯過的句子中的單詞。例如，當我們預測了翻譯目標的前三個單詞時，我們將它們提供給解碼器，然後解碼器使用編碼器的所有輸入來嘗試預測第四個單詞。",qt,$e,Rl="爲了在訓練過程中加快速度（當模型可以訪問目標句子時），解碼器會被輸入整個目標，但不允許獲取到要翻譯的單詞（如果它在嘗試預測位置2的單詞時可以訪問位置2的單詞，解碼器就會偷懶，直接輸出那個單詞，從而無法學習到正確的語言關係！）。例如，當試圖預測第4個單詞時，注意力層只能獲取位置1到3的單詞。",Bt,Ce,Dl="最初的Transformer架構如下所示，編碼器位於左側，解碼器位於右側：",Rt,H,Al='<img class="block dark:hidden" src="https://huggingface.co/datasets/huggingface-course/documentation-images/resolve/main/en/chapter1/transformers.svg" alt="Architecture of a Transformers models"/> <img class="hidden dark:block" src="https://huggingface.co/datasets/huggingface-course/documentation-images/resolve/main/en/chapter1/transformers-dark.svg" alt="Architecture of a Transformers models"/>',Dt,_e,Il="注意，解碼器塊中的第一個注意力層關聯到解碼器的所有（過去的）輸入，但是第二注意力層使用編碼器的輸出。因此，它可以訪問整個輸入句子，以最好地預測當前單詞。這是非常有用的，因爲不同的語言可以有語法規則將單詞按不同的順序排列，或者句子後面提供的一些上下文可能有助於確定給定單詞的最佳翻譯。",At,ke,Vl="也可以在編碼器/解碼器中使用<em>注意力遮罩層</em>，以防止模型注意某些特殊單詞。例如，在批處理句子時，填充特殊詞使所有句子的長度一致。",It,be,Vt,Le,zl=`在本課程中，當我們深入探討Transformers模型時，您將看到
架構、參數和模型
。 這些術語的含義略有不同：`,zt,He,Gl="<li><strong>架構</strong>: 這是模型的骨架 — 每個層的定義以及模型中發生的每個操作。</li> <li><strong>Checkpoints</strong>: 這些是將在給架構中結構中加載的權重。</li> <li><strong>模型</strong>: 這是一個籠統的術語，沒有“架構”或“參數”那麼精確：它可以指兩者。爲了避免歧義，本課程使用將使用架構和參數。</li>",Gt,we,Ul="例如，BERT是一個架構，而 <code>bert-base-cased</code>， 這是谷歌團隊爲BERT的第一個版本訓練的一組權重參數，是一個參數。我們可以說“BERT模型”和”<code>bert-base-cased</code>模型.”",Ut,Me,Nt,ye,Yt;return w=new d({props:{title:"Transformers 是如何工作的？",local:"transformers-是如何工作的",headingTag:"h1"}}),M=new Zl({props:{chapter:1,classNames:"absolute z-10 right-0 top-0"}}),y=new d({props:{title:"一點Transformers的發展歷史",local:"一點transformers的發展歷史",headingTag:"h2"}}),A=new d({props:{title:"Transformers是語言模型",local:"transformers是語言模型",headingTag:"h2"}}),U=new d({props:{title:"Transformer是大模型",local:"transformer是大模型",headingTag:"h2"}}),S=new St({props:{id:"ftWlj4FBHTg"}}),Q=new d({props:{title:"遷移學習",local:"遷移學習",headingTag:"h2"}}),X=new St({props:{id:"BqqfQnyjmgg"}}),se=new d({props:{title:"一般的體系結構",local:"一般的體系結構",headingTag:"h2"}}),ae=new St({props:{id:"H39Z_720T5s"}}),re=new d({props:{title:"介紹",local:"介紹",headingTag:"h2"}}),ge=new d({props:{title:"注意力層",local:"注意力層",headingTag:"h2"}}),Te=new d({props:{title:"原始的結構",local:"原始的結構",headingTag:"h2"}}),be=new d({props:{title:"架構與參數",local:"架構與參數",headingTag:"h2"}}),Me=new Jl({props:{source:"https://github.com/huggingface/course/blob/main/chapters/zh-TW/chapter1/4.mdx"}}),{c(){x=a("meta"),Ee=s(),Pe=a("p"),je=s(),m(w.$$.fragment),qe=s(),m(M.$$.fragment),Be=s(),P=a("p"),P.textContent=Wt,Re=s(),m(y.$$.fragment),De=s(),E=a("p"),E.textContent=Ot,Ae=s(),T=a("div"),T.innerHTML=Qt,Ie=s(),j=a("p"),j.innerHTML=Xt,Ve=s(),q=a("ul"),q.innerHTML=Zt,ze=s(),B=a("p"),B.textContent=Jt,Ge=s(),R=a("ul"),R.innerHTML=Kt,Ue=s(),D=a("p"),D.textContent=el,Ne=s(),m(A.$$.fragment),Ye=s(),I=a("p"),I.textContent=tl,Se=s(),V=a("p"),V.innerHTML=ll,Fe=s(),z=a("p"),z.innerHTML=nl,We=s(),h=a("div"),h.innerHTML=sl,Oe=s(),G=a("p"),G.innerHTML=il,Qe=s(),$=a("div"),$.innerHTML=al,Xe=s(),m(U.$$.fragment),Ze=s(),N=a("p"),N.textContent=rl,Je=s(),C=a("div"),C.innerHTML=fl,Ke=s(),Y=a("p"),Y.textContent=ml,et=s(),_=a("div"),_.innerHTML=ol,tt=s(),m(S.$$.fragment),lt=s(),F=a("p"),F.textContent=ul,nt=s(),W=a("p"),W.textContent=pl,st=s(),O=a("p"),O.textContent=gl,it=s(),m(Q.$$.fragment),at=s(),m(X.$$.fragment),rt=s(),Z=a("p"),Z.innerHTML=vl,ft=s(),k=a("div"),k.innerHTML=cl,mt=s(),J=a("p"),J.textContent=dl,ot=s(),K=a("p"),K.innerHTML=xl,ut=s(),ee=a("ul"),ee.innerHTML=Tl,pt=s(),te=a("p"),te.innerHTML=hl,gt=s(),b=a("div"),b.innerHTML=$l,vt=s(),le=a("p"),le.textContent=Cl,ct=s(),ne=a("p"),ne.textContent=_l,dt=s(),m(se.$$.fragment),xt=s(),ie=a("p"),ie.textContent=kl,Tt=s(),m(ae.$$.fragment),ht=s(),m(re.$$.fragment),$t=s(),fe=a("p"),fe.textContent=bl,Ct=s(),me=a("ul"),me.innerHTML=Ll,_t=s(),L=a("div"),L.innerHTML=Hl,kt=s(),oe=a("p"),oe.textContent=wl,bt=s(),ue=a("ul"),ue.innerHTML=Ml,Lt=s(),pe=a("p"),pe.textContent=Pl,Ht=s(),m(ge.$$.fragment),wt=s(),ve=a("p"),ve.innerHTML=yl,Mt=s(),ce=a("p"),ce.textContent=El,Pt=s(),de=a("p"),de.textContent=jl,yt=s(),xe=a("p"),xe.textContent=ql,Et=s(),m(Te.$$.fragment),jt=s(),he=a("p"),he.textContent=Bl,qt=s(),$e=a("p"),$e.textContent=Rl,Bt=s(),Ce=a("p"),Ce.textContent=Dl,Rt=s(),H=a("div"),H.innerHTML=Al,Dt=s(),_e=a("p"),_e.textContent=Il,At=s(),ke=a("p"),ke.innerHTML=Vl,It=s(),m(be.$$.fragment),Vt=s(),Le=a("p"),Le.textContent=zl,zt=s(),He=a("ul"),He.innerHTML=Gl,Gt=s(),we=a("p"),we.innerHTML=Ul,Ut=s(),m(Me.$$.fragment),Nt=s(),ye=a("p"),this.h()},l(e){const t=Ql("svelte-u9bgzb",document.head);x=r(t,"META",{name:!0,content:!0}),t.forEach(l),Ee=i(e),Pe=r(e,"P",{}),Nl(Pe).forEach(l),je=i(e),o(w.$$.fragment,e),qe=i(e),o(M.$$.fragment,e),Be=i(e),P=r(e,"P",{"data-svelte-h":!0}),f(P)!=="svelte-1mp6q2g"&&(P.textContent=Wt),Re=i(e),o(y.$$.fragment,e),De=i(e),E=r(e,"P",{"data-svelte-h":!0}),f(E)!=="svelte-r02s3v"&&(E.textContent=Ot),Ae=i(e),T=r(e,"DIV",{class:!0,"data-svelte-h":!0}),f(T)!=="svelte-u8zu2n"&&(T.innerHTML=Qt),Ie=i(e),j=r(e,"P",{"data-svelte-h":!0}),f(j)!=="svelte-qhxtrp"&&(j.innerHTML=Xt),Ve=i(e),q=r(e,"UL",{"data-svelte-h":!0}),f(q)!=="svelte-71wfan"&&(q.innerHTML=Zt),ze=i(e),B=r(e,"P",{"data-svelte-h":!0}),f(B)!=="svelte-2bcow"&&(B.textContent=Jt),Ge=i(e),R=r(e,"UL",{"data-svelte-h":!0}),f(R)!=="svelte-yp01ew"&&(R.innerHTML=Kt),Ue=i(e),D=r(e,"P",{"data-svelte-h":!0}),f(D)!=="svelte-htbgag"&&(D.textContent=el),Ne=i(e),o(A.$$.fragment,e),Ye=i(e),I=r(e,"P",{"data-svelte-h":!0}),f(I)!=="svelte-7b7w2s"&&(I.textContent=tl),Se=i(e),V=r(e,"P",{"data-svelte-h":!0}),f(V)!=="svelte-hkf6mv"&&(V.innerHTML=ll),Fe=i(e),z=r(e,"P",{"data-svelte-h":!0}),f(z)!=="svelte-wn0b77"&&(z.innerHTML=nl),We=i(e),h=r(e,"DIV",{class:!0,"data-svelte-h":!0}),f(h)!=="svelte-lvew4p"&&(h.innerHTML=sl),Oe=i(e),G=r(e,"P",{"data-svelte-h":!0}),f(G)!=="svelte-ujkwgj"&&(G.innerHTML=il),Qe=i(e),$=r(e,"DIV",{class:!0,"data-svelte-h":!0}),f($)!=="svelte-1r8x2dd"&&($.innerHTML=al),Xe=i(e),o(U.$$.fragment,e),Ze=i(e),N=r(e,"P",{"data-svelte-h":!0}),f(N)!=="svelte-3q4xk"&&(N.textContent=rl),Je=i(e),C=r(e,"DIV",{class:!0,"data-svelte-h":!0}),f(C)!=="svelte-5uz5bp"&&(C.innerHTML=fl),Ke=i(e),Y=r(e,"P",{"data-svelte-h":!0}),f(Y)!=="svelte-pwcao1"&&(Y.textContent=ml),et=i(e),_=r(e,"DIV",{class:!0,"data-svelte-h":!0}),f(_)!=="svelte-1a8euan"&&(_.innerHTML=ol),tt=i(e),o(S.$$.fragment,e),lt=i(e),F=r(e,"P",{"data-svelte-h":!0}),f(F)!=="svelte-716bq8"&&(F.textContent=ul),nt=i(e),W=r(e,"P",{"data-svelte-h":!0}),f(W)!=="svelte-l2xewz"&&(W.textContent=pl),st=i(e),O=r(e,"P",{"data-svelte-h":!0}),f(O)!=="svelte-1dhc7i9"&&(O.textContent=gl),it=i(e),o(Q.$$.fragment,e),at=i(e),o(X.$$.fragment,e),rt=i(e),Z=r(e,"P",{"data-svelte-h":!0}),f(Z)!=="svelte-xe0s46"&&(Z.innerHTML=vl),ft=i(e),k=r(e,"DIV",{class:!0,"data-svelte-h":!0}),f(k)!=="svelte-152v0kx"&&(k.innerHTML=cl),mt=i(e),J=r(e,"P",{"data-svelte-h":!0}),f(J)!=="svelte-18t4m90"&&(J.textContent=dl),ot=i(e),K=r(e,"P",{"data-svelte-h":!0}),f(K)!=="svelte-1ortaks"&&(K.innerHTML=xl),ut=i(e),ee=r(e,"UL",{"data-svelte-h":!0}),f(ee)!=="svelte-1e1hicw"&&(ee.innerHTML=Tl),pt=i(e),te=r(e,"P",{"data-svelte-h":!0}),f(te)!=="svelte-8icn9b"&&(te.innerHTML=hl),gt=i(e),b=r(e,"DIV",{class:!0,"data-svelte-h":!0}),f(b)!=="svelte-1ngyuh1"&&(b.innerHTML=$l),vt=i(e),le=r(e,"P",{"data-svelte-h":!0}),f(le)!=="svelte-1j4wqd7"&&(le.textContent=Cl),ct=i(e),ne=r(e,"P",{"data-svelte-h":!0}),f(ne)!=="svelte-264szs"&&(ne.textContent=_l),dt=i(e),o(se.$$.fragment,e),xt=i(e),ie=r(e,"P",{"data-svelte-h":!0}),f(ie)!=="svelte-1k5hyfj"&&(ie.textContent=kl),Tt=i(e),o(ae.$$.fragment,e),ht=i(e),o(re.$$.fragment,e),$t=i(e),fe=r(e,"P",{"data-svelte-h":!0}),f(fe)!=="svelte-1s52ger"&&(fe.textContent=bl),Ct=i(e),me=r(e,"UL",{"data-svelte-h":!0}),f(me)!=="svelte-u3vq7n"&&(me.innerHTML=Ll),_t=i(e),L=r(e,"DIV",{class:!0,"data-svelte-h":!0}),f(L)!=="svelte-l70qs1"&&(L.innerHTML=Hl),kt=i(e),oe=r(e,"P",{"data-svelte-h":!0}),f(oe)!=="svelte-10l52vf"&&(oe.textContent=wl),bt=i(e),ue=r(e,"UL",{"data-svelte-h":!0}),f(ue)!=="svelte-kkav1o"&&(ue.innerHTML=Ml),Lt=i(e),pe=r(e,"P",{"data-svelte-h":!0}),f(pe)!=="svelte-1uz3gfw"&&(pe.textContent=Pl),Ht=i(e),o(ge.$$.fragment,e),wt=i(e),ve=r(e,"P",{"data-svelte-h":!0}),f(ve)!=="svelte-5ffvsp"&&(ve.innerHTML=yl),Mt=i(e),ce=r(e,"P",{"data-svelte-h":!0}),f(ce)!=="svelte-1ead0qc"&&(ce.textContent=El),Pt=i(e),de=r(e,"P",{"data-svelte-h":!0}),f(de)!=="svelte-1s8luyr"&&(de.textContent=jl),yt=i(e),xe=r(e,"P",{"data-svelte-h":!0}),f(xe)!=="svelte-6rqkv0"&&(xe.textContent=ql),Et=i(e),o(Te.$$.fragment,e),jt=i(e),he=r(e,"P",{"data-svelte-h":!0}),f(he)!=="svelte-1cenukw"&&(he.textContent=Bl),qt=i(e),$e=r(e,"P",{"data-svelte-h":!0}),f($e)!=="svelte-1o2hqlw"&&($e.textContent=Rl),Bt=i(e),Ce=r(e,"P",{"data-svelte-h":!0}),f(Ce)!=="svelte-1s081t0"&&(Ce.textContent=Dl),Rt=i(e),H=r(e,"DIV",{class:!0,"data-svelte-h":!0}),f(H)!=="svelte-14wvpqf"&&(H.innerHTML=Al),Dt=i(e),_e=r(e,"P",{"data-svelte-h":!0}),f(_e)!=="svelte-1psou36"&&(_e.textContent=Il),At=i(e),ke=r(e,"P",{"data-svelte-h":!0}),f(ke)!=="svelte-l5cn2y"&&(ke.innerHTML=Vl),It=i(e),o(be.$$.fragment,e),Vt=i(e),Le=r(e,"P",{"data-svelte-h":!0}),f(Le)!=="svelte-1g9pnbh"&&(Le.textContent=zl),zt=i(e),He=r(e,"UL",{"data-svelte-h":!0}),f(He)!=="svelte-1r0u36k"&&(He.innerHTML=Gl),Gt=i(e),we=r(e,"P",{"data-svelte-h":!0}),f(we)!=="svelte-102t8y"&&(we.innerHTML=Ul),Ut=i(e),o(Me.$$.fragment,e),Nt=i(e),ye=r(e,"P",{}),Nl(ye).forEach(l),this.h()},h(){c(x,"name","hf:doc:metadata"),c(x,"content",en),c(T,"class","flex justify-center"),c(h,"class","flex justify-center"),c($,"class","flex justify-center"),c(C,"class","flex justify-center"),c(_,"class","flex justify-center"),c(k,"class","flex justify-center"),c(b,"class","flex justify-center"),c(L,"class","flex justify-center"),c(H,"class","flex justify-center")},m(e,t){Xl(document.head,x),n(e,Ee,t),n(e,Pe,t),n(e,je,t),u(w,e,t),n(e,qe,t),u(M,e,t),n(e,Be,t),n(e,P,t),n(e,Re,t),u(y,e,t),n(e,De,t),n(e,E,t),n(e,Ae,t),n(e,T,t),n(e,Ie,t),n(e,j,t),n(e,Ve,t),n(e,q,t),n(e,ze,t),n(e,B,t),n(e,Ge,t),n(e,R,t),n(e,Ue,t),n(e,D,t),n(e,Ne,t),u(A,e,t),n(e,Ye,t),n(e,I,t),n(e,Se,t),n(e,V,t),n(e,Fe,t),n(e,z,t),n(e,We,t),n(e,h,t),n(e,Oe,t),n(e,G,t),n(e,Qe,t),n(e,$,t),n(e,Xe,t),u(U,e,t),n(e,Ze,t),n(e,N,t),n(e,Je,t),n(e,C,t),n(e,Ke,t),n(e,Y,t),n(e,et,t),n(e,_,t),n(e,tt,t),u(S,e,t),n(e,lt,t),n(e,F,t),n(e,nt,t),n(e,W,t),n(e,st,t),n(e,O,t),n(e,it,t),u(Q,e,t),n(e,at,t),u(X,e,t),n(e,rt,t),n(e,Z,t),n(e,ft,t),n(e,k,t),n(e,mt,t),n(e,J,t),n(e,ot,t),n(e,K,t),n(e,ut,t),n(e,ee,t),n(e,pt,t),n(e,te,t),n(e,gt,t),n(e,b,t),n(e,vt,t),n(e,le,t),n(e,ct,t),n(e,ne,t),n(e,dt,t),u(se,e,t),n(e,xt,t),n(e,ie,t),n(e,Tt,t),u(ae,e,t),n(e,ht,t),u(re,e,t),n(e,$t,t),n(e,fe,t),n(e,Ct,t),n(e,me,t),n(e,_t,t),n(e,L,t),n(e,kt,t),n(e,oe,t),n(e,bt,t),n(e,ue,t),n(e,Lt,t),n(e,pe,t),n(e,Ht,t),u(ge,e,t),n(e,wt,t),n(e,ve,t),n(e,Mt,t),n(e,ce,t),n(e,Pt,t),n(e,de,t),n(e,yt,t),n(e,xe,t),n(e,Et,t),u(Te,e,t),n(e,jt,t),n(e,he,t),n(e,qt,t),n(e,$e,t),n(e,Bt,t),n(e,Ce,t),n(e,Rt,t),n(e,H,t),n(e,Dt,t),n(e,_e,t),n(e,At,t),n(e,ke,t),n(e,It,t),u(be,e,t),n(e,Vt,t),n(e,Le,t),n(e,zt,t),n(e,He,t),n(e,Gt,t),n(e,we,t),n(e,Ut,t),u(Me,e,t),n(e,Nt,t),n(e,ye,t),Yt=!0},p:Sl,i(e){Yt||(p(w.$$.fragment,e),p(M.$$.fragment,e),p(y.$$.fragment,e),p(A.$$.fragment,e),p(U.$$.fragment,e),p(S.$$.fragment,e),p(Q.$$.fragment,e),p(X.$$.fragment,e),p(se.$$.fragment,e),p(ae.$$.fragment,e),p(re.$$.fragment,e),p(ge.$$.fragment,e),p(Te.$$.fragment,e),p(be.$$.fragment,e),p(Me.$$.fragment,e),Yt=!0)},o(e){g(w.$$.fragment,e),g(M.$$.fragment,e),g(y.$$.fragment,e),g(A.$$.fragment,e),g(U.$$.fragment,e),g(S.$$.fragment,e),g(Q.$$.fragment,e),g(X.$$.fragment,e),g(se.$$.fragment,e),g(ae.$$.fragment,e),g(re.$$.fragment,e),g(ge.$$.fragment,e),g(Te.$$.fragment,e),g(be.$$.fragment,e),g(Me.$$.fragment,e),Yt=!1},d(e){e&&(l(Ee),l(Pe),l(je),l(qe),l(Be),l(P),l(Re),l(De),l(E),l(Ae),l(T),l(Ie),l(j),l(Ve),l(q),l(ze),l(B),l(Ge),l(R),l(Ue),l(D),l(Ne),l(Ye),l(I),l(Se),l(V),l(Fe),l(z),l(We),l(h),l(Oe),l(G),l(Qe),l($),l(Xe),l(Ze),l(N),l(Je),l(C),l(Ke),l(Y),l(et),l(_),l(tt),l(lt),l(F),l(nt),l(W),l(st),l(O),l(it),l(at),l(rt),l(Z),l(ft),l(k),l(mt),l(J),l(ot),l(K),l(ut),l(ee),l(pt),l(te),l(gt),l(b),l(vt),l(le),l(ct),l(ne),l(dt),l(xt),l(ie),l(Tt),l(ht),l($t),l(fe),l(Ct),l(me),l(_t),l(L),l(kt),l(oe),l(bt),l(ue),l(Lt),l(pe),l(Ht),l(wt),l(ve),l(Mt),l(ce),l(Pt),l(de),l(yt),l(xe),l(Et),l(jt),l(he),l(qt),l($e),l(Bt),l(Ce),l(Rt),l(H),l(Dt),l(_e),l(At),l(ke),l(It),l(Vt),l(Le),l(zt),l(He),l(Gt),l(we),l(Ut),l(Nt),l(ye)),l(x),v(w,e),v(M,e),v(y,e),v(A,e),v(U,e),v(S,e),v(Q,e),v(X,e),v(se,e),v(ae,e),v(re,e),v(ge,e),v(Te,e),v(be,e),v(Me,e)}}}const en='{"title":"Transformers 是如何工作的？","local":"transformers-是如何工作的","sections":[{"title":"一點Transformers的發展歷史","local":"一點transformers的發展歷史","sections":[],"depth":2},{"title":"Transformers是語言模型","local":"transformers是語言模型","sections":[],"depth":2},{"title":"Transformer是大模型","local":"transformer是大模型","sections":[],"depth":2},{"title":"遷移學習","local":"遷移學習","sections":[],"depth":2},{"title":"一般的體系結構","local":"一般的體系結構","sections":[],"depth":2},{"title":"介紹","local":"介紹","sections":[],"depth":2},{"title":"注意力層","local":"注意力層","sections":[],"depth":2},{"title":"原始的結構","local":"原始的結構","sections":[],"depth":2},{"title":"架構與參數","local":"架構與參數","sections":[],"depth":2}],"depth":1}';function tn(Ft){return Fl(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class fn extends Wl{constructor(x){super(),Ol(this,x,tn,Kl,Yl,{})}}export{fn as component};
